//
//  SoundUtil.hpp
//  SynthEco
//
//

#ifndef SoundUtil_h
#define SoundUtil_h
#include <sndfile.h>

using namespace std;

class SoundUtil {
public:
    static void writeWAV(vector<double> &wave, int channels = 1, string filename = "test.wav"){
        SF_INFO sfinfo ;
        sfinfo.channels = channels;
        sfinfo.samplerate = 44100;
        sfinfo.format = SF_FORMAT_WAV | SF_FORMAT_PCM_16;
        
        const char* path = string("/tmp/").append(filename).c_str();
        cout << "Writing wav: " << path << endl;
        cout << "Sample length: " << wave.size() << endl;
        SNDFILE * outfile = sf_open(path, SFM_WRITE, &sfinfo);
        sf_count_t count = sf_write_double(outfile, &wave[0], wave.size()) ;
        sf_write_sync(outfile);
        sf_close(outfile);
        cout << "Written: " << count << endl;
    }
    
};

#endif /* SoundUtil_h */
